// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'WebImage.pas' rev: 4.00

#ifndef WebImageHPP
#define WebImageHPP

#pragma delphiheader begin
#pragma option push -w-
#include <WinInet.hpp>	// Pascal unit
#include <ActiveX.hpp>	// Pascal unit
#include <ComObj.hpp>	// Pascal unit
#include <Dialogs.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Webimage
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TPicturePosition { bpTopLeft, bpTopRight, bpBottomLeft, bpBottomRight, bpCenter, bpTiled, bpStretched 
	};
#pragma option pop

struct TInternetContent;
typedef TInternetContent *PInternetContent;

class DELPHICLASS TWebPicture;
typedef void __fastcall (__closure *TDownloadProgressEvent)(System::TObject* Sender, unsigned dwSize
	, unsigned dwTotSize);

typedef void __fastcall (__closure *TDownloadCancelEvent)(System::TObject* Sender, bool &Cancel);

typedef void __fastcall (__closure *TDownloadCompleteEvent)(System::TObject* Sender);

typedef void __fastcall (__closure *TDownloadErrorEvent)(System::TObject* Sender, AnsiString err);

#pragma pack(push, 4)
class PASCALIMPLEMENTATION TWebPicture : public Graphics::TGraphic 
{
	typedef Graphics::TGraphic inherited;
	
private:
	Classes::TMemoryStream* fDatastream;
	bool fIsEmpty;
	bool fStretched;
	_di_IPicture gpPicture;
	int fLogPixX;
	int fLogPixY;
	AnsiString fURL;
	AnsiString fID;
	bool fAsynch;
	bool fThreadBusy;
	TDownloadProgressEvent fOnDownLoadProgress;
	TDownloadCancelEvent fOnDownLoadCancel;
	TDownloadCompleteEvent fOnDownLoadComplete;
	TDownloadErrorEvent fOnDownLoadError;
	void __fastcall LoadPicture(void);
	
protected:
	virtual bool __fastcall GetEmpty(void);
	virtual int __fastcall GetHeight(void);
	virtual int __fastcall GetWidth(void);
	virtual void __fastcall SetHeight(int Value);
	virtual void __fastcall SetWidth(int Value);
	virtual void __fastcall ReadData(Classes::TStream* Stream);
	virtual void __fastcall WriteData(Classes::TStream* Stream);
	virtual void __fastcall Draw(Graphics::TCanvas* ACanvas, const Windows::TRect &Rect);
	void __fastcall DownLoadError(AnsiString err);
	void __fastcall DownLoadComplete(void);
	void __fastcall DownLoadCancel(bool &cancel);
	void __fastcall DownLoadProgress(unsigned dwSize, unsigned dwTotSize);
	void __fastcall DownLoad(void);
	
public:
	__fastcall virtual TWebPicture(void);
	__fastcall virtual ~TWebPicture(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	virtual void __fastcall LoadFromFile(const AnsiString FileName);
	virtual void __fastcall LoadFromStream(Classes::TStream* Stream);
	virtual void __fastcall SaveToStream(Classes::TStream* Stream);
	void __fastcall LoadFromResourceName(unsigned Instance, const AnsiString ResName);
	void __fastcall LoadFromResourceID(unsigned Instance, int ResID);
	void __fastcall LoadFromURL(AnsiString url);
	virtual void __fastcall LoadFromClipboardFormat(Word AFormat, unsigned AData, HPALETTE APalette);
	virtual void __fastcall SaveToClipboardFormat(Word &AFormat, unsigned &AData, HPALETTE &APalette);
	__property bool Busy = {read=fThreadBusy, nodefault};
	__property bool Asynch = {read=fAsynch, write=fAsynch, nodefault};
	__property AnsiString ID = {read=fID, write=fID};
	
__published:
	__property bool Stretch = {read=fStretched, write=fStretched, nodefault};
	__property TDownloadErrorEvent OnDownLoadError = {read=fOnDownLoadError, write=fOnDownLoadError};
	__property TDownloadCompleteEvent OnDownLoadComplete = {read=fOnDownLoadComplete, write=fOnDownLoadComplete
		};
	__property TDownloadCancelEvent OnDownLoadCancel = {read=fOnDownLoadCancel, write=fOnDownLoadCancel
		};
	__property TDownloadProgressEvent OnDownLoadProgress = {read=fOnDownLoadProgress, write=fOnDownLoadProgress
		};
};

#pragma pack(pop)

#pragma pack(push, 4)
struct TInternetContent
{
	void *hresource;
	bool complete;
	TWebPicture* webpicture;
} ;
#pragma pack(pop)

class DELPHICLASS TDownLoadThread;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TDownLoadThread : public Classes::TThread 
{
	typedef Classes::TThread inherited;
	
private:
	TWebPicture* webpicture;
	
protected:
	virtual void __fastcall Execute(void);
	
public:
	__fastcall TDownLoadThread(TWebPicture* awebpicture);
public:
	#pragma option push -w-inl
	/* TThread.Destroy */ inline __fastcall virtual ~TDownLoadThread(void) { }
	#pragma option pop
	
};

#pragma pack(pop)

class DELPHICLASS TWebPictureCache;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TWebPictureCache : public Classes::TList 
{
	typedef Classes::TList inherited;
	
private:
	void __fastcall SetPicture(int Index, TWebPicture* Value);
	TWebPicture* __fastcall GetPicture(int Index);
	
public:
	__property TWebPicture* Items[int index] = {read=GetPicture, write=SetPicture/*, default*/};
	TWebPicture* __fastcall AddPicture(void);
	TWebPicture* __fastcall FindPicture(AnsiString ID);
	void __fastcall ClearPictures(void);
public:
	#pragma option push -w-inl
	/* TList.Destroy */ inline __fastcall virtual ~TWebPictureCache(void) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TWebPictureCache(void) : Classes::TList() { }
	#pragma option pop
	
};

#pragma pack(pop)

class DELPHICLASS TWebImage;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TWebImage : public Controls::TGraphicControl 
{
	typedef Controls::TGraphicControl inherited;
	
private:
	TWebPicture* fWebPicture;
	TPicturePosition fPicturePosition;
	TDownloadCancelEvent fOnDownLoadCancel;
	TDownloadCompleteEvent fOnDownLoadComplete;
	TDownloadErrorEvent fOnDownLoadError;
	TDownloadProgressEvent fOnDownLoadProgress;
	void __fastcall SeTWebPicture(const TWebPicture* Value);
	void __fastcall PictureChanged(System::TObject* sender);
	void __fastcall SetPicturePosition(const TPicturePosition Value);
	void __fastcall DownLoadError(System::TObject* Sender, AnsiString err);
	void __fastcall DownLoadComplete(System::TObject* Sender);
	void __fastcall DownLoadCancel(System::TObject* Sender, bool &cancel);
	void __fastcall DownLoadProgress(System::TObject* Sender, unsigned dwSize, unsigned dwTotSize);
	
protected:
	virtual void __fastcall Paint(void);
	
public:
	__fastcall virtual TWebImage(Classes::TComponent* aOwner);
	__fastcall virtual ~TWebImage(void);
	virtual void __fastcall Loaded(void);
	
__published:
	__property TWebPicture* WebPicture = {read=fWebPicture, write=SeTWebPicture};
	__property TPicturePosition PicturePosition = {read=fPicturePosition, write=SetPicturePosition, nodefault
		};
	__property Align ;
	__property Anchors ;
	__property Constraints ;
	__property DragKind ;
	__property DragCursor ;
	__property DragMode ;
	__property Hint ;
	__property ParentShowHint ;
	__property ShowHint ;
	__property Visible ;
	__property OnClick ;
	__property OnDblClick ;
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnEndDock ;
	__property OnStartDock ;
	__property OnEndDrag ;
	__property OnMouseDown ;
	__property OnMouseUp ;
	__property OnMouseMove ;
	__property OnStartDrag ;
	__property TDownloadErrorEvent OnDownLoadError = {read=fOnDownLoadError, write=fOnDownLoadError};
	__property TDownloadCompleteEvent OnDownLoadComplete = {read=fOnDownLoadComplete, write=fOnDownLoadComplete
		};
	__property TDownloadCancelEvent OnDownLoadCancel = {read=fOnDownLoadCancel, write=fOnDownLoadCancel
		};
	__property TDownloadProgressEvent OnDownLoadProgress = {read=fOnDownLoadProgress, write=fOnDownLoadProgress
		};
};

#pragma pack(pop)

//-- var, const, procedure ---------------------------------------------------

}	/* namespace Webimage */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Webimage;
#endif
#pragma option pop	// -w-

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// WebImage
